#include <reg51.h>

#define BUTTON_IDLE     0                                
#define BUTTON_ACTIVE   1
#define STATUS_IDLE     0                                
#define STATUS_ACTIVE   1
#define BUTTON_INIT     1

// OSD position definition

#define OSD_ICON_HSTART (3<<3)
#define OSD_BITMAP_HSTART (4<<3)
#define OSD_ICON_CENTER_HSTART (6<<3)
#define OSD_BITMAP_CENTER_HSTART (3<<3)
#define OSD_VSTART 		(5<<4)           // (1<<4) 
#define OSD_PAL_VSTART (7<<4)   
#define OSD2_VSTART (1<<4)
//  OSD counter definition

#define brightness 1
#define contrast  2
#define saturation 3
#define hue 4




 // I2C Interface definition

 sbit i2c_scl =P0^0;               
 sbit i2c_sda =P0^1;
 sbit i2c_sda_al242 =P0^2;

 // Button definition

sbit _source     = P1^4;
sbit _menu        = P1^3; 
sbit _inc         = P1^0; 
sbit _dec         = P1^1;
sbit _select        = P1^2;
sbit _border      = P1^7; 
sbit _bootlut     = P1^6;
sbit _channel     = P1^5;

 


// AL251.c function
extern void T0serve();
extern void InitTimer0(void);
extern void al251Initialize(void);
extern void alDelay(unsigned int nMS);
extern unsigned char dblAutoDetect(void);
extern void exit(void);
//extern void delay(void);
//extern void dblInitialize(void);
extern void dblSetSystem(unsigned char system, unsigned char crop);
extern void dblSetOverlayColor(unsigned char i, unsigned char r0, unsigned char g0, unsigned char b0);
extern void show_input(unsigned char source);
extern void osdmenu(unsigned int osd_count, unsigned char value);
extern void show_osd(unsigned int osdcount);
extern void show_value(unsigned char value);
extern void OnBorder(void);
extern void dblSetBorderColor(unsigned char r, unsigned char g, unsigned char b);
extern void OnBootLut(void);
extern void dblBootLut(unsigned char R, unsigned char G, unsigned char B);
extern void dlSinBootLut(unsigned char boot);

// AL251i2c.c function

extern unsigned char Get_AL251Register(unsigned char index);
extern void Set_AL251Register(unsigned char index, unsigned char value);
extern unsigned char i2cWrite(unsigned char slave_addr, unsigned char  sub_addr, unsigned char value);
extern unsigned char i2cRead(unsigned char slave_addr, unsigned char  sub_addr);


