// ********************************************************************************
// ********************************************************************************
//                          ==========AVERLOGIC LTD. CO. ==========
//      PROJECT:  AL128+AL251+AL242
//       Function:  Convert VGA into analoge TV video and convert analoge TV video into VGA
//      Designer:  Kim
//      End Date:  07-26-2005
// ********************************************************************************
// ********************************************************************************

#include <reg51.h>
#include "AL251.h"
#include "AL242.h"

// state definition

#define AL251_sel   0
#define AL128_sel   1
#define LED_light    0
#define LED_black  1
#define AL242_Reset      0
#define AL242_Work       1
#define AL251_Reset      0
#define AL251_Work       1

 // LED definition

 sbit _program_good  =P2^7;
 sbit _AL128_LED =P2^6;
 sbit _AL251_LED =P2^5;

// I/O control definition
 
 sbit al251_testin =P0^3;
 sbit al251_square =P0^4;
 sbit reset_al242 =P0^5;                  /*reset AL242*/
 sbit channel_sel =P0^6;                 /* AL128 and AL251 channel select*/
 sbit reset_al251 =P0^7;                /* reset AL251*/

unsigned char channel_flag = 0;     /* channel sate flag, 0--AL128 channel;1--AL251 channel */
unsigned char system = 0;                      /* Default NTSC*/
unsigned char  source = 0;              /* Default Composite; 1= S-Video */ 
unsigned int osdcount = 0;         /*Default Brightness*/
unsigned char osdflag ;
unsigned char i;
unsigned int loop=0;
void main()
{             
	_program_good =LED_light;          // Program run good...... LED light  
	P1 = 0xff;     //pull high P1
	alDelay(20);
	while (1)
	{
	
 // AL128 channel process
		while (channel_flag== 0)         
		{ 
			reset_al242 = AL242_Reset;                // AL242 and AL251 reset
			reset_al251 = AL251_Reset;
			source=0;
			_AL251_LED = LED_black;                 // AL251 select LED black,AL128 select LED light
			_AL128_LED = LED_light;          
			channel_sel = AL128_sel;                   // select AL128 channel
			P1 = 0xff;                                          //pull high P1         
			if (_channel == BUTTON_ACTIVE)               // the channel switch detected
			{
				alDelay(100);  
				while (_channel == BUTTON_ACTIVE);     // add release key detected 
				channel_flag =1-channel_flag;		
			}
		}

//  AL251 channel process  
		al251_square = 0;
		al251_testin = 1;
		_AL128_LED = LED_black;            // AL128 select LED black, AL251 select LED light
//           _AL251_LED = LED_light; 
		reset_al242 = AL242_Work;      // AL242 and AL251 work
		AL242Initialize();
		reset_al251 = AL251_Work;
		al251Initialize();                              // AL251 chip ID check, OSD start position setup and input video mode setup
		_AL251_LED = LED_light;                                  //   AL251 channel readly OK
		channel_sel = AL251_sel;            // select AL251 channel
		show_input(source); 
//		InitTimer0();                 //delay
//		alDelay(1000);
//		exit();    
		while (channel_flag== 1)                              // button scan and command
		{
			loop++;
			osdflag=0;
			osdcount=1;
			AutoDetectProgress();
			P1 = 0xff;                                          //pull high P1
//			alDelay(100); 
			if (system != dblAutoDetect())  
 		  	{
				system = 1 - system;     //AL251 video format detect
				dblSetSystem(system, 0);
			}
// source ( composite or S-Video) switch process 
			if (_source == BUTTON_ACTIVE)           
			{
				reset_al242 = AL242_Reset;
				alDelay(50);  
				reset_al242 = AL242_Work;  
				source =1-source;     
//				if (source==0)
//				{
//					AL242Initialize();
//					InputChannelSelectAL242(source);
//				}
//				else
//				{
					AL242Initialize();
//					InitReg(szPAL_I);
//					SetAL242Reg(0x0a,0x80);
					InputChannelSelectAL242(source);
//				}
				AutoDetectProgress();
//				P1 = 0xff;                                          //pull high P1
//				alDelay(100); 
				if (system != dblAutoDetect())  
 			  	{
					system = 1 - system;     //AL251 video format detect
					dblSetSystem(system, 0);
				}
//				alDelay(100); 
				while (_source == BUTTON_ACTIVE);
				show_input(source); 
				loop=0;
//				InitTimer0();  // delay 
//				alDelay(1000);
//				exit();      
			}
	   		if ( loop==500)          //add  delay loop  hide source show   kim0922
			{
				exit();
				loop=0;
	   		}

// Menu control and command, continuously press button and select function control.
			if (_menu == BUTTON_ACTIVE)
			{
				unsigned char value;
				while (_menu == BUTTON_ACTIVE);  
				while (osdflag==0)
				{
					dblSetOverlayColor(0x00,0x00,0xff,0x00);  
					if (osdcount==5)
					{ 
						osdcount=1;
					} 
                
					if (osdcount==1)
					{ 
						value = dcGetBrightness();         // read current Brightness value
					}
					else if(osdcount == 2)
					{
						value = dcGetContrast();         // read current Contrast value
					}
					else if(osdcount == 3)
					{
						value = dcGetSaturation();        // read current Saturation value
					}
					else if(osdcount == 4)
					{
						value = dcGetHue();                   //read current Hue value
					}
					osdmenu(osdcount,value);        //OSD menu and value display
					osdcount++;                             // OSD menu counter 
					exit();
				}
			}
		
// Exit menu control and command, hide OSD
//			else if (_exit == BUTTON_ACTIVE) 
//			{  
 //				osdflag=0;
//				osdcount=1;
 //				exit(); 
//			}  
		
// Setup border 
			else if (_border == BUTTON_ACTIVE)
			{    
				OnBorder();
			}  
		
// LUT on/off
			else if (_bootlut == BUTTON_ACTIVE)
			{    
				OnBootLut();   
			}  
			else if  (_channel == BUTTON_ACTIVE)   // detect channel button
			{
				while (_channel == BUTTON_ACTIVE);         // add release key detected  
				channel_flag =1-channel_flag;
				alDelay(100);      
			}
		}
	}
}






